// s.bus je na RX pin (PD1)

#include <Arduino.h>
#include <SBUS2.h>
#include <Servo.h>

#define WATER_SENSOR1 A7
#define WATER_SENSOR2 A6
#define WATER_PUMP1 19
#define WATER_PUMP2 18
#define LIGHTS 17
#define LED 13
#define WATER_TRASHOLD 512
#define CH1_OUT 3
#define CH2_OUT 5

//#define TEST 1

int wlTest = 0;
int16_t ch1 = 0;
int16_t ch2 = 0;
int16_t wch1 = 0;
int16_t wch2 = 0;
int16_t lch = 0;
int wlevel1 = 0;
int wlevel2 = 0;
Servo rudderServo;
Servo thrServo;

void setup()
{
    pinMode(WATER_SENSOR1, INPUT_PULLUP);
    pinMode(WATER_SENSOR2, INPUT_PULLUP);
    pinMode(WATER_PUMP1, OUTPUT);
    pinMode(WATER_PUMP2, OUTPUT);
    pinMode(LIGHTS, OUTPUT);
    pinMode(LED, OUTPUT); // test

    digitalWrite(LIGHTS, LOW);
    digitalWrite(WATER_PUMP1, HIGH); 
    digitalWrite(WATER_PUMP2, HIGH); 

    rudderServo.attach(CH1_OUT);
    thrServo.attach(CH2_OUT);
    SBUS2_Setup();
}

void loop()
{
  #if TEST
    wlTest = analogRead(WATER_SENSOR1);
    digitalWrite(LED, wlTest < 512 ? HIGH : LOW);
  #endif    
    if(SBUS_Ready()){                             // SBUS Frames available -> Ready for getting Servo Data
      ch1 = SBUS2_get_servo_data(0); // ch od 0 hodnota 0-2047 (11 bit)
      ch2 = SBUS2_get_servo_data(1);
      wch1 = SBUS2_get_servo_data(5);
      wch2 = SBUS2_get_servo_data(6);
      lch = SBUS2_get_servo_data(7);

      // kormidlo - prosta hodnota ch1
      ch1 = map(ch1, 0, 2047, 900, 2100);
      rudderServo.writeMicroseconds(ch1);
      
      // plyn - prosta hodnota ch2 - BLHeli neumí revers s s.bus, tak to nechám na PWM
      ch2 = map(ch2, 0, 2047, 900, 2100);
      thrServo.writeMicroseconds(ch2);

      // svetla
      if (lch > 1024) {
        digitalWrite(LIGHTS, HIGH);
      } else {
        digitalWrite(LIGHTS, LOW);
      }

      // hladina vody - inverzne, je tam zapnuty interni pullup rezistor
      wlevel1 = analogRead(WATER_SENSOR1);
      wlevel2 = analogRead(WATER_SENSOR2);

      // pokud bude kanal ovladani pumpy mensi jak ~1/3, nechat pumpu vypnutou, mezi 1/3 a 2/3, pumpa bezi, pokud je zaplaveno, nad 2/3 pumpa bezi porad
      // obe pumpy nezavisle
      //setPump(wlevel1, wch1, LED);
      setPump(wlevel1, wch1, WATER_PUMP1);
      setPump(wlevel2, wch2, WATER_PUMP2);
    }
} // End of Loop()

void setPump(int sensor, int channel, int outPump) {
  bool pump =  (channel > 700 && channel < 1400 && sensor < WATER_TRASHOLD) || (channel > 1400); // senzor je zaplaveny pokud je nizsi jak trashold
  if (pump) {
    digitalWrite(outPump, HIGH);  
  } else {
    digitalWrite(outPump, LOW);
  }
}
